
/*
 * UNFS3 server framework
 * Originally generated using rpcgen
 * Portions (C) 2004, Pascal Schmidt <der.eremit@email.de>
 * see file LICENSE for license details
 */

#include <stdarg.h>
#include <rpc/rpc.h>
#include <rpc/pmap_clnt.h>
#include <netinet/in.h>
#include <ownfsd.h>

#if HAVE_RPC_SVC_SOC_H == 1
# include <rpc/svc_soc.h>
#endif


/*
 * NFS service dispatch function
 * generated by rpcgen
 */
void nfs3_program_3(struct svc_req *rqstp, register SVCXPRT * transp) {
    union {
        GETATTR3args nfsproc3_getattr_3_arg;
        SETATTR3args nfsproc3_setattr_3_arg;
        LOOKUP3args nfsproc3_lookup_3_arg;
        ACCESS3args nfsproc3_access_3_arg;
        READLINK3args nfsproc3_readlink_3_arg;
        READ3args nfsproc3_read_3_arg;
        WRITE3args nfsproc3_write_3_arg;
        CREATE3args nfsproc3_create_3_arg;
        MKDIR3args nfsproc3_mkdir_3_arg;
        SYMLINK3args nfsproc3_symlink_3_arg;
        MKNOD3args nfsproc3_mknod_3_arg;
        REMOVE3args nfsproc3_remove_3_arg;
        RMDIR3args nfsproc3_rmdir_3_arg;
        RENAME3args nfsproc3_rename_3_arg;
        LINK3args nfsproc3_link_3_arg;
        READDIR3args nfsproc3_readdir_3_arg;
        READDIRPLUS3args nfsproc3_readdirplus_3_arg;
        FSSTAT3args nfsproc3_fsstat_3_arg;
        FSINFO3args nfsproc3_fsinfo_3_arg;
        PATHCONF3args nfsproc3_pathconf_3_arg;
        COMMIT3args nfsproc3_commit_3_arg;
    } argument;
    xdrproc_t _xdr_argument, _xdr_result;
    void (*local) (char *, struct datapasser_t * );
    struct parsedname pn ;
    struct stateinfo si ;
    struct datapasser_t dp = {&pn, NULL, NULL, } ;

    memset( &pn, 0, sizeof(struct parsedname) ) ;
    pn.si = &si ;
    
    switch (rqstp->rq_proc) {
    case NFSPROC3_NULL:
        LEVEL_CALL("NULL\n")
        _xdr_argument = (xdrproc_t) xdr_void;
        _xdr_result = (xdrproc_t) xdr_void;
        dp.result = NULL ;
        break;
    
    case NFSPROC3_GETATTR:
        LEVEL_CALL("GETATTR\n")
        _xdr_argument = (xdrproc_t) xdr_GETATTR3args;
        _xdr_result = (xdrproc_t) xdr_GETATTR3res;
        dp.result = malloc(sizeof(GETATTR3res)) ;
        local = (void (*)(char *, struct datapasser_t * )) nfsproc3_getattr_3_svc;
        break;
    
    case NFSPROC3_SETATTR:
        LEVEL_CALL("SETATTR\n")
        _xdr_argument = (xdrproc_t) xdr_SETATTR3args;
        _xdr_result = (xdrproc_t) xdr_SETATTR3res;
        dp.result = malloc(sizeof(SETATTR3res)) ;
        local = (void (*)(char *, struct datapasser_t * )) nfsproc3_setattr_3_svc;
        break;
    
    case NFSPROC3_LOOKUP:
        LEVEL_CALL("LOOKUP\n")
        _xdr_argument = (xdrproc_t) xdr_LOOKUP3args;
        _xdr_result = (xdrproc_t) xdr_LOOKUP3res;
        dp.result = malloc(sizeof(LOOKUP3res)) ;
        local = (void (*)(char *, struct datapasser_t * )) nfsproc3_lookup_3_svc;
        break;
    
    case NFSPROC3_ACCESS:
        LEVEL_CALL("ACCESS\n")
        _xdr_argument = (xdrproc_t) xdr_ACCESS3args;
        _xdr_result = (xdrproc_t) xdr_ACCESS3res;
        dp.result = malloc(sizeof(ACCESS3res)) ;
        local = (void (*)(char *, struct datapasser_t * )) nfsproc3_access_3_svc;
        break;
    
    case NFSPROC3_READLINK:
        LEVEL_CALL("READLINK\n")
        _xdr_argument = (xdrproc_t) xdr_READLINK3args;
        _xdr_result = (xdrproc_t) xdr_READLINK3res;
        dp.result = malloc(sizeof(READLINK3res)) ;
        local = (void (*)(char *, struct datapasser_t * )) nfsproc3_readlink_3_svc;
        break;
    
    case NFSPROC3_READ:
        LEVEL_CALL("READ\n")
        _xdr_argument = (xdrproc_t) xdr_READ3args;
        _xdr_result = (xdrproc_t) xdr_READ3res;
        dp.result = malloc(sizeof(READ3res)) ;
        local = (void (*)(char *, struct datapasser_t * )) nfsproc3_read_3_svc;
        break;
    
    case NFSPROC3_WRITE:
        LEVEL_CALL("WRITE\n")
        _xdr_argument = (xdrproc_t) xdr_WRITE3args;
        _xdr_result = (xdrproc_t) xdr_WRITE3res;
        dp.result = malloc(sizeof(WRITE3res)) ;
        local = (void (*)(char *, struct datapasser_t * )) nfsproc3_write_3_svc;
        break;
    
    case NFSPROC3_CREATE:
        LEVEL_CALL("CREATE\n")
        _xdr_argument = (xdrproc_t) xdr_CREATE3args;
        _xdr_result = (xdrproc_t) xdr_CREATE3res;
        dp.result = malloc(sizeof(CREATE3res)) ;
        local = (void (*)(char *, struct datapasser_t * )) nfsproc3_create_3_svc;
        break;
    
    case NFSPROC3_MKDIR:
        LEVEL_CALL("MKDIR\n")
        _xdr_argument = (xdrproc_t) xdr_MKDIR3args;
        _xdr_result = (xdrproc_t) xdr_MKDIR3res;
        dp.result = malloc(sizeof(MKDIR3res)) ;
        local = (void (*)(char *, struct datapasser_t * )) nfsproc3_mkdir_3_svc;
        break;
    
    case NFSPROC3_SYMLINK:
        LEVEL_CALL("SYMLINK\n")
        _xdr_argument = (xdrproc_t) xdr_SYMLINK3args;
        _xdr_result = (xdrproc_t) xdr_SYMLINK3res;
        dp.result = malloc(sizeof(SYMLINK3res)) ;
        local = (void (*)(char *, struct datapasser_t * )) nfsproc3_symlink_3_svc;
        break;
    
    case NFSPROC3_MKNOD:
        LEVEL_CALL("MKNOD\n")
        _xdr_argument = (xdrproc_t) xdr_MKNOD3args;
        _xdr_result = (xdrproc_t) xdr_MKNOD3res;
        dp.result = malloc(sizeof(MKNOD3res)) ;
        local = (void (*)(char *, struct datapasser_t * )) nfsproc3_mknod_3_svc;
        break;
    
    case NFSPROC3_REMOVE:
        LEVEL_CALL("REMOVE\n")
        _xdr_argument = (xdrproc_t) xdr_REMOVE3args;
        _xdr_result = (xdrproc_t) xdr_REMOVE3res;
        dp.result = malloc(sizeof(REMOVE3res)) ;
        local = (void (*)(char *, struct datapasser_t * )) nfsproc3_remove_3_svc;
        break;
    
    case NFSPROC3_RMDIR:
        LEVEL_CALL("RMDIR\n")
        _xdr_argument = (xdrproc_t) xdr_RMDIR3args;
        _xdr_result = (xdrproc_t) xdr_RMDIR3res;
        dp.result = malloc(sizeof(RMDIR3res)) ;
        local = (void (*)(char *, struct datapasser_t * )) nfsproc3_rmdir_3_svc;
        break;
    
    case NFSPROC3_RENAME:
        LEVEL_CALL("RENAME\n")
        _xdr_argument = (xdrproc_t) xdr_RENAME3args;
        _xdr_result = (xdrproc_t) xdr_RENAME3res;
        dp.result = malloc(sizeof(RENAME3res)) ;
        local = (void (*)(char *, struct datapasser_t * )) nfsproc3_rename_3_svc;
        break;
    
    case NFSPROC3_LINK:
        LEVEL_CALL("LINK\n")
        _xdr_argument = (xdrproc_t) xdr_LINK3args;
        _xdr_result = (xdrproc_t) xdr_LINK3res;
        dp.result = malloc(sizeof(LINK3res)) ;
        local = (void (*)(char *, struct datapasser_t * )) nfsproc3_link_3_svc;
        break;
    
    case NFSPROC3_READDIR:
        LEVEL_CALL("READDIR")
        _xdr_argument = (xdrproc_t) xdr_READDIR3args;
        _xdr_result = (xdrproc_t) xdr_READDIR3res;
        dp.result = malloc(sizeof(READDIR3res)) ;
        local = (void (*)(char *, struct datapasser_t * )) nfsproc3_readdir_3_svc;
        break;
    
    case NFSPROC3_READDIRPLUS:
        LEVEL_CALL("READDIRPLUS\n")
        _xdr_argument = (xdrproc_t) xdr_READDIRPLUS3args;
        _xdr_result = (xdrproc_t) xdr_READDIRPLUS3res;
        dp.result = malloc(sizeof(READDIRPLUS3res)) ;
        local = (void (*)(char *, struct datapasser_t * )) nfsproc3_readdirplus_3_svc;
        break;
    
    case NFSPROC3_FSSTAT:
        LEVEL_CALL("FSSTAT\n")
        _xdr_argument = (xdrproc_t) xdr_FSSTAT3args;
        _xdr_result = (xdrproc_t) xdr_FSSTAT3res;
        dp.result = malloc(sizeof(FSSTAT3res)) ;
        local = (void (*)(char *, struct datapasser_t * )) nfsproc3_fsstat_3_svc;
        break;
    
    case NFSPROC3_FSINFO:
        LEVEL_CALL("FSINFO\n")
        _xdr_argument = (xdrproc_t) xdr_FSINFO3args;
        _xdr_result = (xdrproc_t) xdr_FSINFO3res;
        dp.result = malloc(sizeof(FSINFO3res)) ;
        local = (void (*)(char *, struct datapasser_t * )) nfsproc3_fsinfo_3_svc;
        break;
    
    case NFSPROC3_PATHCONF:
        LEVEL_CALL("PATHCONF\n")
        _xdr_argument = (xdrproc_t) xdr_PATHCONF3args;
        _xdr_result = (xdrproc_t) xdr_PATHCONF3res;
        dp.result = malloc(sizeof(PATHCONF3res)) ;
        local = (void (*)(char *, struct datapasser_t * )) nfsproc3_pathconf_3_svc;
        break;
    
    case NFSPROC3_COMMIT:
        LEVEL_CALL("COMMIT\n")
        _xdr_argument = (xdrproc_t) xdr_COMMIT3args;
        _xdr_result = (xdrproc_t) xdr_COMMIT3res;
        dp.result = malloc(sizeof(COMMIT3res)) ;
        local = (void (*)(char *, struct datapasser_t * )) nfsproc3_commit_3_svc;
        break;
    
    default:
        LEVEL_CALL("UNRECOGNIZED NFS CALL\n")
        svcerr_noproc(transp);
        return;
    }
    memset((char *) &argument, 0, sizeof(argument));
    if (dp.result) memset((char *) dp.result, 0, sizeof(dp.result));
    if (!svc_getargs(transp, (xdrproc_t) _xdr_argument, (caddr_t) & argument)) {
        svcerr_decode(transp);
        return;
    }
    if ( dp.result) (*local) ((char *) &argument, &dp );
    FS_ParsedName_destroy(&pn) ;
    if (dp.result != NULL && !svc_sendreply(transp, (xdrproc_t) _xdr_result, dp.result)) {
        svcerr_systemerr(transp);
        LEVEL_CONNECT("unable to send RPC reply, aborting\n")
        ow_exit(2);
    }
    if ( dp.result ) free( dp.result ) ;
    if ( dp.buffer ) free( dp.buffer ) ;
    if (!svc_freeargs(transp, (xdrproc_t) _xdr_argument, (caddr_t) & argument)) {
        LEVEL_CONNECT("unable to free XDR arguments\n")
        ow_exit(2);
    }
    return;
}

static struct groupnode gnode = { "*", NULL, } ;
static struct exportnode exports_list = { "/", &gnode, NULL, } ;

/*
 * mount protocol dispatcher
 * generated by rpcgen
 */
void mountprog_3(struct svc_req *rqstp, register SVCXPRT * transp) {
    union {
        dirpath mountproc_mnt_3_arg;
        dirpath mountproc_umnt_3_arg;
    } argument;
    
    memset((char *) &argument, 0, sizeof(argument));
    LEVEL_CALL("Mount program called.\n")
    switch (rqstp->rq_proc) {
    case MOUNTPROC_MNT:
    {
        mountres3 result ;
        LEVEL_CALL("MOUNT: MNT\n")
        if (!svc_getargs(transp, (xdrproc_t) xdr_dirpath, (caddr_t) & argument)) {
            svcerr_decode(transp);
            return;
        }
        LEVEL_CALL("MOUNT: MNT directory = %s\n",argument.mountproc_mnt_3_arg)
        if ( strcmp( "/" , argument.mountproc_mnt_3_arg ) ) {
            result.fhs_status = MNT3ERR_INVAL ;
        } else {
            unfs3_fh_t fh ;
            int auth[1] = { AUTH_NONE, } ;
            
            /* filehandle of root directory (only mountpoint allowed) */
            memset( &fh, 0, sizeof(unfs3_fh_t) ) ; /* file handle of root directory!!! */
            result.mountres3_u.mountinfo.fhandle.fhandle3_len = sizeof(unfs3_fh_t) ;
            result.mountres3_u.mountinfo.fhandle.fhandle3_val = (char *) (&fh) ;
            result.fhs_status = MNT3_OK ;

            /* auth_flavors should be set */
            result.mountres3_u.mountinfo.auth_flavors.auth_flavors_len = 1 ;
            result.mountres3_u.mountinfo.auth_flavors.auth_flavors_val = auth ;
        }
        if (!svc_sendreply(transp, (xdrproc_t) xdr_mountres3, (char *) (&result) )) {
            svcerr_systemerr(transp);
        }
        if (!svc_freeargs(transp, (xdrproc_t) xdr_dirpath, (caddr_t) & argument)) {
            LEVEL_CONNECT("unable to free XDR arguments\n")
            ow_exit(2);
        }
    }
        return ;   
    case MOUNTPROC_EXPORT:
        LEVEL_CALL("MOUNT: EXPORT\n")
        if (!svc_sendreply(transp, (xdrproc_t) xdr_exports, (char *)(&exports_list) )) {
            svcerr_systemerr(transp);
        }
        return;
    case MOUNTPROC_DUMP:
        LEVEL_CALL("MOUNT: DUMP\n")
        return ;
    case MOUNTPROC_UMNT:
        LEVEL_CALL("MOUNT: UMNT\n")
        return ;
    case MOUNTPROC_UMNTALL:
        LEVEL_CALL("MOUNT: UMNTALL\n")
        return ;
    case MOUNTPROC_NULL:
        LEVEL_CALL("MOUNT: NULL\n")
        return ;
    default:
        LEVEL_CALL("MOUNT: UNRECOGNIZED\n")
        return;
    }
}
